VERSION 5.00
Object = "{F79181C9-C287-43DF-AA44-AEA9A2239229}#1.0#0"; "FvxComImage.dll"
Object = "{F79BCF41-8C30-11D5-8E38-00024404787B}#1.0#0"; "FvxComCalcData.dll"
Object = "{59C7F1C8-ABC2-4BFA-B7B4-A53BB7CD0B4A}#1.0#0"; "FvxComDisplayEx.dll"
Begin VB.Form frmSetCircleRobust 
   BorderStyle     =   1  'Œ()
   Caption         =   "Outer circle"
   ClientHeight    =   9210
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7995
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9210
   ScaleWidth      =   7995
   StartUpPosition =   3  'Windows ̊l
   Begin FVXCOMDISPLAYEXLibCtl.FvxDisplayEx FvxDisplayEx1 
      Height          =   7455
      Left            =   0
      OleObjectBlob   =   "frmSetCircleRobust.frx":0000
      TabIndex        =   5
      Top             =   0
      Width           =   7935
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   435
      Left            =   5160
      TabIndex        =   4
      Top             =   7980
      Width           =   1335
   End
   Begin VB.CommandButton cmdRobust 
      Caption         =   "Execute"
      Height          =   435
      Left            =   6600
      TabIndex        =   2
      Top             =   7980
      Width           =   1215
   End
   Begin VB.TextBox txtRobustWeight 
      Alignment       =   1  'E
      Height          =   315
      Left            =   6960
      TabIndex        =   1
      Text            =   "10"
      Top             =   7560
      Width           =   735
   End
   Begin FVXCOMIMAGELibCtl.FvxImage FvxImage1 
      Left            =   3960
      OleObjectBlob   =   "frmSetCircleRobust.frx":014A
      Top             =   7980
   End
   Begin FVXCOMCALCDATALibCtl.FvxCalcData FvxCalcData1 
      Left            =   4560
      OleObjectBlob   =   "frmSetCircleRobust.frx":0198
      Top             =   7980
   End
   Begin VB.Label lblMessage 
      Caption         =   "Message"
      Height          =   1455
      Left            =   120
      TabIndex        =   3
      Top             =   7620
      Width           =   4575
   End
   Begin VB.Label Label7 
      Alignment       =   1  'E
      Caption         =   "Robust presumption weight"
      Height          =   195
      Left            =   4800
      TabIndex        =   0
      Top             =   7620
      Width           =   1935
   End
End
Attribute VB_Name = "frmSetCircleRobust"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2002                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -------------------------------------------------------------------
' FVX Sample Program
' Robust presumption

'
' Maker : K.Kotajima
'
' History : 2002/06/19 First edition
'
' -------------------------------------------------------------------
Option Explicit


Private m_Circle As New FvCircle

Private m_blnIsCircleSet As Boolean 'Do finishing [ a setup of a circle ] or not?

Private m_blnIsSelecting As Boolean 'Under coordinates selection

'Coordinates
Private m_lngPointDataX(100) As Long
Private m_lngPointDataY(100) As Long
Private m_PointNum As Long      'The number of coordinates

'It investigates whether the circle was set up or not.
Public Property Get CheckCircle() As Boolean
    CheckCircle = m_blnIsCircleSet
End Property


Public Sub GetCircle(pCircle As FvCircle)
    pCircle.X = m_Circle.X
    pCircle.Y = m_Circle.Y
    pCircle.radius = m_Circle.radius
End Sub

Private Sub Form_Load()

    m_PointNum = 0
    m_blnIsSelecting = True
    m_blnIsCircleSet = False
    
    frmMain.FvxImage1.CopyTo Me.FvxImage1
    FvxDisplayEx1.CreateDisplay
    FvxDisplayEx1.DrawImage Me.FvxImage1

    lblMessage.Caption = "This process is to calculate circumference by performing robust presumption against the set point." & vbCrLf & _
                          "Select more than 3 points on the circumference and click 'Execute' button."
  
 
                          
End Sub

'Specification of point coordinates
Private Sub FvxDisplayEx1_MouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long, ByVal InOut As Long)
    
    If m_blnIsSelecting = True Then
    
        If m_PointNum < 100 Then
            m_lngPointDataX(m_PointNum) = X
            m_lngPointDataY(m_PointNum) = Y
            
            DrawCrossMark X, Y
            
            m_PointNum = m_PointNum + 1
        Else
            MsgBox "100 or more points cannot be specified.", , "Error"
        End If
    End If

End Sub

'Cancel
Private Sub cmdCancel_Click()
    'It changes into the state where it does not set up, at the time of cancellation, and it is ended.
    m_blnIsCircleSet = False
    Unload Me
End Sub

'Execute
Private Sub cmdRobust_Click()

    Dim pPoint As New FvPoint
    Dim dblWeight As Double
    Dim lngErr As Long
    Dim i As Long
    
    m_blnIsSelecting = False
    
    dblWeight = Val(txtRobustWeight.Text)
    
    On Error Resume Next
    
    If m_PointNum >= 3 Then
        
        'A coordinates point is set.
        For i = 0 To m_PointNum - 1
            pPoint.X = m_lngPointDataX(i)
            pPoint.Y = m_lngPointDataY(i)
            FvxCalcData1.SetPoint i, pPoint
        Next
        
        'Execution of robust presumption
        FvxCalcData1.CalcCircle_Robust m_PointNum, dblWeight
        'It is confirmed whether the error has come out.
        FvxCalcData1.GetErrReport lngErr
        If lngErr = 0 Then
        
            'A result is acquired.
            FvxCalcData1.CalcCircle_GetResult m_Circle
            FvxDisplayEx1.DrawData 0, m_Circle
            DoEvents
        
            If MsgBox("Is it good at this result?", vbYesNo) = vbYes Then
                'A circle is determined and this dialog is ended.
                m_blnIsCircleSet = True
                Unload Me
            Else
                'Coordinates data is cleared and it is re-specification.
                FvxDisplayEx1.ClearOverlay
                m_blnIsCircleSet = False
                m_blnIsSelecting = True
                m_PointNum = 0
            End If
        
        Else
            MsgBox "Robust presumption went wrong." & vbCrLf & "Coordinates data is cleared.", , "Error"
            'Coordinates data is cleared and it is re-specification.
            FvxDisplayEx1.ClearOverlay
            m_blnIsCircleSet = False
            m_blnIsSelecting = True
            m_PointNum = 0
        End If
    Else
        MsgBox "There are too few specifying points.", , "Error"
    End If
    
    Set pPoint = Nothing
End Sub

'x mark is displayed.
Private Sub DrawCrossMark(lng_x As Long, lng_y As Long)
    
    Dim pLineSeg As New FvLineSegment
    
    FvxDisplayEx1.PenColor = RGB(0, 0, 255)
    
    pLineSeg.xs = lng_x - 5
    pLineSeg.ys = lng_y - 5
    pLineSeg.xe = lng_x + 5
    pLineSeg.ye = lng_y + 5
    FvxDisplayEx1.DrawData 0, pLineSeg
    
    pLineSeg.xs = lng_x - 5
    pLineSeg.ys = lng_y + 5
    pLineSeg.xe = lng_x + 5
    pLineSeg.ye = lng_y - 5
    FvxDisplayEx1.DrawData 0, pLineSeg
    
    Set pLineSeg = Nothing

End Sub

